import random
import time

class SessionStore():
    # Always remember the *self* argument
    def __init__(self,parent,i, l,pn,n,t,cc):

        self.simulationIndex = i
        self.nextSimulation = -1
        self.startIn= -1
        self.connectionIndex = cc
        self.initialized = False
        self.sendingInfo = 0
        self.workload = -1

        #sesion time        
        self.status = "Pauze" # "Started" - "Ended"
        self.parent= parent
        self.session_time = 0
        self.session_time_total = 30*60
        self.score_time = 0
        self.time_sting = "0:00:00"
        self.time_sting_total = "0:30:00"

        #session info
        self.patientLetter = l
        self.patientName = pn
        self.number = n
        self.therapy = t

        #sud
        self.sud = 3.5
        self.sud2 = 3.5
        self.sud3 = 3.5
        self.i=0    #index for drawing

        #score
        self.score = 0
        self.avg_score = 0
        self.avg_response = 0
        self.state = "Good (+1)"

        self.sudExtreme = 8
        self.sudMax = 7
        self.sudMin = 3


        self.warn6 = 0
        self.warn8 = 0
        self.warn3 = 0


        #log file
        time2 = time.strftime('%a %d %B %Y')
        #time3 = time.strftime('%H:%M:%S')
        self.log = "Logfile:\n\nDate: "+ time2 +"\nPatient name: " + pn + "\nSession Number: " + str(n) + "\nTherapy type: " + t +"\n\n"

        #Lock actions:
        self.Lock_talkToPatient = 0
        self.Lock_scenario = 0

        #arrays
        self.h =3650 #1*60*60 # aantal historie
        self.history = [0.0 for i in range(self.h)]
        self.history[0]=3.5
        self.nextkill = -1

        self.eaArray = []  #eqspecter actions array
        self.correct = 0      #number of errors
        self.error = 0      #number of errors
        self.cancel = 0
        self.RemoteAssist = 0

        self.flagArray = []
        self.sim=SessionSimulation(self)

    def update(self):


        if  self.patientName == "Mr.Aalders":
          self.sudExtreme = 7
          self.sudMax = 5
          self.sudMin = 2
        if  self.patientName == "Mr.de Bruin":
          self.sudExtreme = 9
          self.sudMax = 7
          self.sudMin = 3
        if  self.patientName == "Mrs.Carstens":
          self.sudExtreme = 8
          self.sudMax = 6
          self.sudMin = 3


        self.sud2 = self.sud
        self.time_sting_total = self.Give_time_sting(self.session_time_total,1)
        if self.status =="Started":
          if self.session_time<self.session_time_total:
            self.session_time = self.session_time + 1
            self.i=self.i+1
            self.time_sting = self.Give_time_sting(self.session_time,1)
          else:
            self.sessionEnd()

          #score
          if self.sud>self.sudMax:
            self.state = "To High (-1)"
          elif self.sud<self.sudMin:
            self.state = "To Low (-1)"
          else:
            self.state = "Good (+1)"
          if self.state == "Good (+1)":
            self.score = self.score + 1
          if self.state == "To High (-1)":
            self.score = self.score - 0
          if self.state == "To Low (-1)":
            self.score = self.score - 0




          ttime = self.session_time - self.score_time
          if ttime == 0:
             ttime = 1
          self.avg_score = self.score*1.00/ttime*1.00
          #self.avg_score = round(avg_score,3)


          #if self.isleegEa()==True:
          #      self.warn6 = 0
          #      self.warn8 = 0
          #      self.warn3 = 0
          #print str(self.warn3)


          if self.sud>self.sudMax and self.sud<self.sudExtreme and self.warn6 == 0:
                self.parent.parent.simulationCreator.defEa("SE6", self, self.session_time)
                self.warn6 = 1

          if self.sud>self.sudExtreme and self.warn8 == 0:
                self.parent.parent.simulationCreator.defEa("SE8", self, self.session_time)
                self.warn8 = 1

          if self.sud<self.sudMin and self.warn3 == 0:
                self.parent.parent.simulationCreator.defEa("SE3", self, self.session_time)
                self.warn3 = 1

          if self.sud<(self.sudMax-1):
                self.warn6 = 0
                self.warn8 = 0

          if self.sud>(self.sudMin+1):
                self.warn3 = 0




          self.Lock_talkToPatient = self.Lock_talkToPatient - 1
          self.Lock_scenario = self.Lock_scenario-1

          self.history[self.i]=self.sud2
          self.sim.update(self.session_time)


        if self.status =="Pauze":
          if self.startIn > -1:
            self.startIn = self.startIn -1
            if self.startIn == 0:
               self.sessionStart() 


        if self.sendingInfo == 1:
          self.parent.parent.commandOut("SETPATIENT#"+str(self.patientLetter)+"#"+str(self.patientName) ,  self.connectionIndex)
          self.sendingInfo = 2

        elif self.sendingInfo == 2:
          self.parent.parent.commandOut("SETTHERAPY#"+str(self.number)+"#"+str(self.therapy) ,  self.connectionIndex)
          self.sendingInfo = 3

        elif self.sendingInfo == 3:
          self.parent.parent.commandOut("SETLENGTH#" + str(self.session_time_total),self.connectionIndex)
          self.sendingInfo = 4

        elif self.sendingInfo == 4:
          if self.parent.assist==True:
                self.parent.parent.commandOut("ASSIST",self.connectionIndex)
          else:
                self.parent.parent.commandOut("NOASSIST",self.connectionIndex)
          self.sendingInfo = 5

        elif self.sendingInfo == 5:
          self.parent.parent.commandOut("SETLENGTH#" + str(self.session_time_total),self.connectionIndex)
          self.sendingInfo = 6

        elif self.sendingInfo == 6:
          self.sendingInfo = 7

        elif self.sendingInfo == 7:
          if self.parent.assist==True:
                self.parent.parent.commandOut("ASSIST",self.connectionIndex)
          else:
                self.parent.parent.commandOut("NOASSIST",self.connectionIndex)
          self.sendingInfo = 0



#session start
    def sendInfo(self):    #send the session info

          self.sendingInfo = 1

          #self.parent.parent.commandOut("SETPATIENT#"+str(self.patientLetter)+"#"+str(self.patientName) ,  self.connectionIndex)
          #self.parent.parent.commandOut("SETTHERAPY#"+str(self.number)+"#"+str(self.therapy) ,  self.connectionIndex)
          #self.parent.parent.commandOut("SETLENGTH#" + str(self.session_time_total),self.connectionIndex)
          #if self.parent.assist==True:
          #      self.parent.parent.commandOut("ASSIST",self.connectionIndex)
          #else:
          #      self.parent.parent.commandOut("NOASSIST",self.connectionIndex)


    def sessionStart(self):  #start the session
        self.status = "Started"
        self.parent.parent.commandOut("START" ,  self.connectionIndex)

    def sessionEnd(self):
        self.time_sting = self.Give_time_sting(self.session_time,1)
        self.time_sting_total = self.Give_time_sting(self.session_time_total,1)
        self.status = "Ended"
        if self.nextSimulation > -1:
            self.parent.continueToSession(self.simulationIndex,self.nextSimulation)

    def reset(self):

        self.status= "Pauze"
        self.i=0
        self.history = [0.0 for i in range(self.h)]
        self.session_time = 0
        self.session_time_total = 30*60
        self.time_sting = "0:00:00"
        self.time_sting_total = "0:30:00"

        self.adjustArray = []
        self.flagArray = []
        self.sud = 3.5
        self.sud2 = 3.5
        self.sud3 = 3.5
        self.history[0]=self.sud

        self.sim=SessionSimulation(self)
        self.score_time = 0
        self.score = 0
        self.avg_score = 0
        self.avg_response = 0
        self.warn6 = 0
        self.warn8 = 0
        self.warn3 = 0

        self.sudExtreme = 8
        self.sudMax = 7
        self.sudMin = 3


# acpected actions
    def GetEaArrayString(self):
        temp = ""
        for i in range(len(self.eaArray)):


          if self.eaArray[i].protocol <>"":
            temp = temp + " >"+ self.eaArray[i].protocol + " = "
          temp = temp + self.eaArray[i].eatype
          temp = temp + str(self.eaArray[i].number)
          if self.eaArray[i].finished == False:
            temp = temp + "[ ]  "
          else:
            if self.eaArray[i].finishedTime >0:
                temp = temp + "[" + str(self.eaArray[i].finishedTime)+"]  "
            else:
                temp = temp + "[x]  "


        return temp

    def CheckEa(self,ea,nr):   #check if a Action has to be made and then mark it...
        ##get last open ea
        ii = 0
        go = 0

        for i in range(len(self.eaArray)):
          if self.eaArray[i].finished == True:
              ii = i +1

        #check and fill....
        for i in range(len(self.eaArray)):
           if self.eaArray[i].finished == False:
               self.eaArray[i].check(ea,nr,self.session_time)

               if self.eaArray[i].finished == True:
                  self.correct = self.correct+1
                  patienttalk = self.eaArray[ii].returnString
                  if patienttalk <>"":
                     self.parent.parent.commandOut("ADJUST#0#1#" + str(patienttalk) ,  self.connectionIndex)
                  #fill up....
                  for j in range (0,i):
                     if self.eaArray[j].finished == False:
                            self.error=self.error+1
                            self.eaArray[j].finished = True

                  go =1
                  break

        if go ==0:
            self.error=self.error+1


        #avrg responce time
        t= 0
        r = 0
        for i in range(len(self.eaArray)):
          r = r + self.eaArray[i].finishedTime
          if self.eaArray[i].finished and self.eaArray[i].finishedTime >0:
              t=t+1
        if t == 0:
            t=1

        self.avg_response = r*1.0/t*1.0


    def RemoveLastEa(self):   #remove the last ea
        ##get last open ea
        ii = -1
        go = 0
        for i in range(len(self.eaArray)):
          if self.eaArray[i].finished == True and self.eaArray[i].eatype=="P":
              ii = i

        if ii>-1:
            self.eaArray[ii].finished = False
            self.cancel=self.cancel+1

    def isleegEa(self):   #remove the last ea

        temp = False

        t =  len(self.eaArray)

        if t > 0:
          if self.eaArray[t-1].finished == True:
              temp = True

        return temp


    def autoCorrectEa(self):

        for i in range(len(self.eaArray)):
          if self.eaArray[i].finished == False:
             self.eaArray[i].finished = True
             self.correct = self.correct+1


#flags
    def setFlag(self,flag,flagtype,timesec):
        newFlag = Flag(flag,flagtype,timesec)
        self.flagArray.append(newFlag)

    def Give_time_sting(self,sec,scale):
        tst = sec*scale
        ts = int(tst)
        tm=int((tst /60))
        th=int((tst /(60*60)))
        tm=tm-(th*60)
        ts=ts-(tm*60)-(th*60*60)
        self.st_s=str(ts)
        if len(self.st_s)==1:
         self.st_s = "0"+str(ts)
        self.st_m=str(tm)
        if len(self.st_m)==1:
         self.st_m = "0"+str(tm)
        time_sting_total=str(th)+":"+self.st_m+":"+self.st_s
        return time_sting_total

    def getSting(self):
        temp = ""
        t= str(self.number)
        tt= str(self.patientName)
        ttt= str(self.therapy)
        tttt= str(self.time_sting)
        ttttt= str(self.time_sting_total)
        b= (self.status)
        if self.startIn >-1  and   self.status == "Pauze":
            b= "Start in: " + str(self.startIn)
        iii= " Conn: " + str(self.connectionIndex)
        if self.connectionIndex ==-1:
            iii= ""
        iiii= " ]-> " + str(self.nextSimulation)
        if self.nextSimulation ==-1:
            iiii= " ]"
        temp = temp + t + " " + tt + "_"+ ttt + "  |  "+ tttt + "-"+ ttttt + "   [ " + b + iiii + iii
        return temp



#--- helper classes  ----------------------------------

class SessionSimulation():
    # Always remember the *self* argument
    def __init__(self, session):

        self.session =  session
        self.adjustArray = []
        self.create()


    def create(self):
        pass
        #self.addSim(5,60, "TEST TEST",30)
        #self.addSim(-5,60, "TEST TEST",60)
        #self.addSim(-2,500, "TEST TEST",120)


    def update(self, tl):
        tp=None
        for i in range(len(self.adjustArray)):
          temp = self.adjustArray[i]
          if (temp.goTime < tl) and (temp.fired == False):
            tp = temp

        if tp <> None:
          time = tp.time
          sud = tp.totalSud
          string = tp.patientTalk
          code = tp.code
          tp.fired = True


          if code=="SET":
            self.session.parent.parent.commandOut("SUD#"+str(sud), self.session.connectionIndex)
          elif code=="LEVEL":
            self.session.parent.level = sud
          elif code=="ASKWORKLOAD":

            self.session.parent.parent.askWorkload()

          else:
            self.session.parent.parent.commandOut("ADJUST#"+str(sud) + "#" + str(time)+ "#" + string ,  self.session.connectionIndex)
            self.session.parent.parent.simulationCreator.defEa(code, self.session, tl)


    def addSim(self,c ,sud,timesec, strig, time):
        newAdjust = SimAdjust(c, sud,timesec, strig, time )
        self.adjustArray.append(newAdjust)

    def reset(self):
        self.adjustArray = []

class SimAdjust():
    # Always remember the *self* argument
    def __init__(self,code,sud,timesec, string,time):

        if timesec < 1:
            timesec = 1
        self.code = code
        self.goTime = time
        self.time = timesec
        self.totalSud = sud
        self.patientTalk = string
        self.counter = 0
        self.sudStap = (sud*1.0/self.time*1.0)
        self.kill = False
        self.fired = False
    def update(self, time):
        if (time >= self.goTime) and (time< self.goTime + self.time):
            return self.sudStap
        else:
            return 0  

    def patientalk(self, time):
        if (time == self.goTime):
            return self.patientTalk
        else:
            return ""
    def String(self):
        return str(self.totalSud) + " - " +  str(self.time) + " Talk: [" +   self.patientTalk + "]  At:" +   str(self.goTime)



class ExpectedAction():
    # Always remember the *self* argument
    def __init__(self,protocol,eatype,number,timesec, ss):

        if timesec < 1:
            timesec = 1

        self.eatype = eatype
        self.number = number
        self.actionTime = timesec
        self.finishedTime = 0
        self.finished = False

        self.returnString = ss

        self.protocol=protocol

    def check(self, ea, nr ,time):

        if self.finished == False:
          if ea == self.eatype and nr == self.number :
              self.finished = True
              self.finishedTime = time - self.actionTime
              return self.returnString
          else:
            return ""
        else:
          return ""

class Flag():
    # Always remember the *self* argument
    def __init__(self,flag,flagtype,timesec):

        if timesec < 1:
            timesec = 1

        self.flag = flag
        self.time = timesec
        self.flagtype = flagtype

    def update(self):
        #temp = QtGui.QPixmap("res/Patient_view.jpg")
        temp = "res/flag.png"

        if self.flagtype ==1:
            return "res/flag/flag1.png"
        elif self.flagtype ==2:
            return "res/flag/flag2.png"
        elif self.flagtype ==3:
            return "res/flag/flag3.png"
        elif self.flagtype ==4:
            return "res/flag/flag4.png"
        elif self.flagtype ==5:
            return "res/flag/flag5.png"
        elif self.flagtype ==6:
            return "res/flag/flag_sud.png"
        elif self.flagtype ==7:
            return "res/flag/flag_aa.png"
        elif self.flagtype ==8:
            return "res/flag/flag_ra.png"
        else:
            return temp