
from PyQt4 import QtGui, QtCore

from PyQt4.QtCore import *
from threading import *

#from MyCommunication import *


import socket
import sys


class MyConnection(QtCore.QThread):
   def __init__(self, send, host,port):
       QtCore.QThread.__init__(self)
       self.alive = 1
       self.running = 1

       self.log ="-Start- /n"
       self.initialized = False

       self.host=host
       self.send = send
       self.port = port

       self.connected = False
       self.command = ""
       self.Output = ""
       self.temp = ""
       self.start()
       self.rec = 0
       self.LastIn = ""
       self.LastOut = ""
       self.lo=0

   def getString(self):

        tt = "R[" + self.LastIn   + "]"
        if self.send == True:
            tt = "S[" + self.LastOut+ "]"

        ll = " -o-"
        if self.connected == True:
            ll = " -x-"
        if self.rec >0:
            ll = " -R-"
            self.rec=self.rec-1

        temp = str(self.port) + "-" + tt
        return temp

   def sendCommand(self,text):

        if self.command =="":
            self.command = text
        else:
            self.command = self.command + "|" + text


   def run(self):
       while self.alive:
           while self.running:

               if self.send==True:
                    self.updateSend()
               else:
                    self.updateRecieve()

               self.msleep(40)
           self.msleep(40)


   def updateSend(self):

       #step one make connection
       if self.connected == False:
         self.ontvanger = MyCommunication(self, self.host, self.port, self.send)
         self.connected = True

       #connection succsesfull
       else:
         self.log=self.log+"."
         self.lo = self.lo -1
         if self.lo < 0:
            self.LastOut = ""

         if self.command <> "":
            self.ontvanger.send_char(self.command + "|")
            self.log=self.log+"*"
            self.LastOut = self.command
            self.command = ""
            self.lo = 20

   def updateRecieve(self):

       #step one make connection
       if self.connected == False:
         self.ontvanger = MyCommunication(self, self.host, self.port, self.send)

         if self.ontvanger.connected == True:
            self.connected = True

       #connection succsesfull
       else:
         data = self.ontvanger.s.recv(1)

         if data <> "|" :
            self.temp=self.temp+ data
            self.log=self.log+ ""
         else:
            self.Output = self.temp
            self.temp = ""
            self.log=self.log+ str(self.Output)

            self.rec = 15
            self.LastIn = self.Output




class MyCommunication:
    def __init__ (self, parent, host, port, send):

    # create a socket to server
        self.host=host
        self.parent = parent
        self.port = port
        self.send = send       #true is sender- False is recever
        self.connected = False
        if send==False:
            self.ConnectReceve()
        else:
            self.ConnectSend()




    def ConnectSend(self):

        # create a socket
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        # associate the socket with a port
        self.host = '' # can leave this blank on the server side
        #port = 2000 #int(sys.argv[1])
        print "Deze computer naam: "+str(socket.gethostname()) #+"\n"
        print "Deze computer IP adres: "+str(socket.gethostbyname(socket.gethostname())) +"\n" #\n"
        self.s.bind((self.host, self.port))

        self.parent.log=self.parent.log+ "Ik wacht op een verbinding: start alstublieft de wereld op de patient computer.\n"

        # accept "call" from client
        self.s.listen(1)
        self.conn, self.addr = self.s.accept()
        #print 'client connected at', self.addr
        self.parent.log=self.parent.log+ 'Client verbonden op ' + str(self.addr) +"\n"


    def ConnectReceve(self):
        self.parent.log=self.parent.log+"Looking "
        self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

        try:
            self.s.connect((self.host, self.port))
            self.conn = self.s
            self.parent.log=self.parent.log+ ' -- Found -- Now connected to ' + self.host  + "\n"
            self.connected = True

        except:
            self.connected = False


    def send_char(self,z):
        ## wait for the go-ahead signal from the keyboard (to demonstrate that
        ## recv() at the client will block until server sends)
        self.conn.sendall(z)

