import random
import time
from PyQt4 import QtGui, QtCore


class Session():
    # Always remember the *self* argument
    def __init__(self,parent, l,pn,n,t):

        #sesion time

        self.assist=False
        self.alarm=False
        self.cancel=False
        self.parent = parent
        self.session_time = 0
        self.session_time_total = 30*60
        self.time_sting = "0:00:00"
        self.time_sting_total = "0:30:00"
        self.sudAlarm = 7

        #session info
        self.patientLetter = l
        self.patientName = pn
        self.number = n
        self.therapy = t

        self.status = "Pauze" # "Started" - "Ended"

        #sud
        self.sud = 3.5
        self.sud2 = 3.5
        self.sud3 = 3.5
        self.i=0    #index for drawing
        self.h =3650 #1*60*60 # aantal historie
        self.history = [0.0 for i in range(self.h)]
        self.history[0]=3.5
        self.nextkill = -1

        #adjust
        self.maxAdjust = 400 #sec
        self.adjustArray = []
        self.numberOfAdjusts = 0
        self.flagArray = []

        #patent
        self.patientTalk = "I am ready to start"
        self.oldpatientTalk = ""
        self.talkTimer = 0

        #score
        self.score = 0
        self.state = "Good (+1)"
        self.sudMax = 7
        self.sudMin = 3


        #log file
        time2 = time.strftime('%a %d %B %Y')
        #time3 = time.strftime('%H:%M:%S')
        self.log = "Logfile:\n\nDate: "+ time2 +"\nPatient name: " + pn + "\nSession Number: " + str(n) + "\nTherapy type: " + t +"\n\n"

        #Lock actions:
        self.Lock_talkToPatient = 0
        self.Lock_scenario = 0
        self.image = "sud1"
        self.l_sud = 0


    def update(self):

        if  self.patientName == "Mr.Aalders":
          self.sudAlarm  = 5
        if  self.patientName == "Mr.de Bruin":
          self.sudAlarm  = 7
        if  self.patientName == "Mrs.Carstens":
           self.sudAlarm  = 6


        self.time_sting_total = self.Give_time_sting(self.session_time_total,1)  

        if self.status =="Started":

          if self.session_time<self.session_time_total:
            self.session_time = self.session_time + 1
            self.i=self.i+1
            self.time_sting = self.Give_time_sting(self.session_time,1)
          else:
            self.sessionEnd()

          #score
          if self.sud>self.sudMax:
            self.state = "To High (-1)"
          elif self.sud<self.sudMin:
            self.state = "To Low (-1)"
          else:
            self.state = "Good (+1)"
  
          if self.state == "Good (+1)":
            self.score = self.score + 1
          if self.state == "To High (-1)":
            self.score = self.score - 1
          if self.state == "To Low (-1)":
            self.score = self.score - 1

          self.Lock_talkToPatient = self.Lock_talkToPatient - 1
          if self.Lock_talkToPatient <=0:
              self.cancel=False
          self.Lock_scenario = self.Lock_scenario-1

        #sud
        rand = random.randint(-11.00,11.00)
        random.jumpahead(1)
        rand=rand*0.006
        self.sud3=self.sud3+rand
        rand = random.randint(1,10000)
        random.jumpahead(1)
        if rand==5:
            self.sud3 = 0
        if self.sud3>0.4:
            self.sud3 = 0
        if self.sud3<-0.4:
            self.sud3 = 0
        self.sud2 = self.sud + self.sud3


        #adjust
        for i in range(len(self.adjustArray)):
          self.nextkill = -1
          temp2 = 0
          temp = self.adjustArray[i]
          temp2 = temp.update()
          self.sud = self.sud + temp2
          if temp.kill== True:
            self.nextkill = i
        if self.nextkill >-1:
            self.adjustArray.pop(self.nextkill)
            self.nextkill = -1

        if self.sud<0:
            self.sud=0
        if self.sud>9.9:
            self.sud=9.9
        if self.sud2<0:
            self.sud2=0
        if self.sud2>9.9:
            self.sud2=9.9

        self.history[self.i]=self.sud2

        #patient talk
        if self.oldpatientTalk <> self.patientTalk:
          self.talkTimer = 3   #int((0.1 * self.mainTimeScale) + 2)
          if self.patientTalk<>"":
            #self.log = self.log + "[ " + self.Give_time_sting(self.session_time,1) + " ] - Patient talk: " + self.patientTalk + "\n"

            self.parent.TSIC.soundUpdate()

        self.oldpatientTalk  = self.patientTalk


        #Assist
        if self.assist==True and self.alarm==False:
          if self.sud>self.sudAlarm:
              #self.patientTalk ="Over 6 Over 6!"
              self.parent.setAlarm()
              self.alarm=True

        if self.sud<(self.sudAlarm):
            self.alarm=False

        #patient talk
       # if self.talkTimer > 0:
       #   self.talkTimer = self.talkTimer -1
       # elif self.talkTimer == 0:
       #   self.patientTalk = ""


    def talkUpdate(self):
        pass
        #patient talk
        if self.talkTimer > 0:
          self.talkTimer = self.talkTimer -1
        elif self.talkTimer == 0:
          self.patientTalk = ""



    def sessionEnd(self):
        self.time_sting = self.Give_time_sting(self.session_time,1)
        self.time_sting_total = self.Give_time_sting(self.session_time_total,1)
        self.status = "Ended"

    def reset(self):
        self.status= "Pauze"
        self.i=0
        self.history = [0.0 for i in range(self.h)]
        self.session_time = 0
        self.session_time_total = 30*60
        self.time_sting = "0:00:00"
        self.time_sting_total = "0:30:00"

        self.patientLetter = "A"
        self.patientName = "None"
        self.number = -1
        self.therapy = "None"

        self.adjustArray = []
        self.flagArray = []
        self.sud = 3.5
        self.sud2 = 3.5  
        self.sud3 = 3.5
        self.history[0]=self.sud


        self.assist=False
        self.alarm=False
        self.cancel=False

        self.parent.w_vwView.image= QtGui.QPixmap("res/ruis.jpg")
        self.parent.tpvw.w_pView.image= QtGui.QPixmap("res/ruis.jpg")

    def setTotaltimeDown(self):
        tt=-5*60
        if self.session_time_total >5*60:
            self.session_time_total = self.session_time_total + tt
        self.time_sting_total = self.Give_time_sting(self.session_time_total,1)
        self.parent.commandOut("SETLENGTH#" +str(self.session_time_total))

    def setTotaltimeUp(self):
        tt=5*60
        if self.session_time_total <1*60*60:
            self.session_time_total = self.session_time_total + tt
        self.time_sting_total = self.Give_time_sting(self.session_time_total,1)
        self.parent.commandOut("SETLENGTH#"+str(self.session_time_total))

    def ajustSud(self,sud,timesec, string):
        if string <>"":
            self.patientTalk = string
        newAdjust = Ajustment(sud,timesec, string)
        self.adjustArray.append(newAdjust)
        self.numberOfAdjusts=self.numberOfAdjusts+1
        self.l_sud = sud


    def reverseLastEA(self):
        #print str(self.l_sud)
        self.ajustSud(-1*(self.l_sud),4, "rr")

    def setFlag(self,flag,flagtype,timesec):
        newFlag = Flag(flag,flagtype,timesec)
        self.flagArray.append(newFlag)
        self.parent.commandOut("FLAG#" + str(flag) + "#" + str(flagtype) + "#" + str(timesec))

        self.log = self.log + "[ " + self.Give_time_sting(self.session_time,1) + " ] - Flag: " + str(flag) + "\n"


#main----------------------

    def AdjustSimulation2(self,ea, ean, sud,time,flag,flagtype,patientTalk,locktime,lockwhat):




        #send
        self.parent.commandOut("EA#" + ea +"#" + str(ean))

        if self.status <> "Pauze":

          #locktime
          if lockwhat =="patient":
              self.Lock_talkToPatient = locktime
              self.parent.commandOut("LOCKP#"+ str(locktime))
              self.cancel=True

          elif lockwhat =="scenario":
              self.Lock_scenario = locktime
              self.parent.commandOut("LOCKS#"+ str(locktime))

          self.ajustSud(sud,time, patientTalk)  #+patient

          if flag <>"":
              self.setFlag(flag, flagtype , self.session_time)

        else:
            self.patientTalk = "The session is not running."

    def AdjustSimulation(self,ea, ean, sud,time,flag,flagtype,patenttalk,locktime,lockwhat):
        def function():
            self.AdjustSimulation2(ea, ean,sud,time,flag,flagtype,patenttalk,locktime,lockwhat)
        return function

    #oplossing
    #def callBackFunction(self,argument):
    #    self.ajustSud(-1,1)
    #
    #def createCallBackFunction(self,argument):
    #    def function():
    #        self.callBackFunction(argument)
    #
    #    return function


    def Give_time_sting(self,sec,scale):
        tst = sec*scale

        ts = int(tst)
        tm=int((tst /60))
        th=int((tst /(60*60)))

        tm=tm-(th*60)
        ts=ts-(tm*60)-(th*60*60)

        self.st_s=str(ts)
        if len(self.st_s)==1:
         self.st_s = "0"+str(ts)

        self.st_m=str(tm)
        if len(self.st_m)==1:
         self.st_m = "0"+str(tm)

        time_sting_total=str(th)+":"+self.st_m+":"+self.st_s

        return time_sting_total

#--- helper classes

class Ajustment():
    # Always remember the *self* argument
    def __init__(self,sud,timesec, string):

        if timesec < 1:
            timesec = 1

        self.time = timesec
        self.totalSud = sud
        self.patientTalk = string
        self.counter = 0
        self.sudStap = (sud*1.0/self.time*1.0)
        self.kill = False

    def update(self):
        self.counter = self.counter +1

        if self.counter-1 < self.time:
            return self.sudStap

        else:
            self.kill = True
            return 0


class Flag():
    # Always remember the *self* argument
    def __init__(self,flag,flagtype,timesec):

        if timesec < 1:
            timesec = 1

        self.flag = flag
        self.time = timesec
        self.flagtype = flagtype

    def update(self):
        #temp = QtGui.QPixmap("res/Patient_view.jpg")
        temp = "res/flag.png"

        if self.flagtype ==1:
            return "res/flag/flag1.png"
        elif self.flagtype ==2:
            return "res/flag/flag2.png"
        elif self.flagtype ==3:
            return "res/flag/flag3.png"
        elif self.flagtype ==4:
            return "res/flag/flag4.png"
        elif self.flagtype ==5:
            return "res/flag/flag5.png"
        elif self.flagtype ==6:
            return "res/flag/flag_sud.png"
        elif self.flagtype ==7:
            return "res/flag/flag_aa.png"
        elif self.flagtype ==8:
            return "res/flag/flag_ra.png"
        else:
            return temp

