import random
import time
from PyQt4 import QtGui, QtCore


class TherapistSoundImageControl():
    # Always remember the *self* argument
    def __init__(self,parent, session):

        self.parent = parent
        self.session = session

        self.envirment = 1
        self.viewCount = 0

        self.sound = QtGui.QSound("sound/leeg.wav")

        self.bells = QtGui.QSound("sound/alarm.wav")
        #self.bells.play()
        #self.bells.play()
        #QtGui.QSound.play("sound/alarm2.wav");


    def playAlarm(self):
        self.bells.play()




    def soundUpdate(self):

        self.sound = QtGui.QSound("sound/leeg.wav")
        talk = self.session.patientTalk
        patient = "p1"
        if self.session.patientName=="Mr.Aalders":
            patient = "p1"
        if self.session.patientName=="Mr.de Bruin":
            patient = "p2"
        if self.session.patientName=="Mrs.Carstens":
            patient = "p3"




        if talk == "Ik heb een vraag":
            self.sound = QtGui.QSound("sound/" + patient + "/a.wav")
        if talk == "Het scenario is afgelopen":
            self.sound = QtGui.QSound("sound/" + patient + "/b.wav")

        if talk == "Kan ik het opstijgen nog een keer proberen?":
            self.sound = QtGui.QSound("sound/" + patient + "/c.wav")
        if talk == "Kan ik het landen nog een keer proberen?":
            self.sound = QtGui.QSound("sound/" + patient + "/d.wav")
        if talk == "De vlucht is nu wel erg kalm":
            self.sound = QtGui.QSound("sound/" + patient + "/e.wav")

        if talk == "Ik ben klaar met het gesprek":
            self.sound = QtGui.QSound("sound/" + patient + "/f.wav")
        if talk == "Deze persoon bevalt me niet!":
            self.sound = QtGui.QSound("sound/" + patient + "/g.wav")
        if talk == "Dit gesprek bevalt me niet!":
            self.sound = QtGui.QSound("sound/" + patient + "/g2.wav")
        if talk == "Het onderwerp van het gesprek is te makkelijk":
            self.sound = QtGui.QSound("sound/" + patient + "/g3.wav")
        if talk == "Het onderwerp van het gesprek is veel te moeilijk":
            self.sound = QtGui.QSound("sound/" + patient + "/g4.wav")

        if talk == "Dank u wel":
            self.sound = QtGui.QSound("sound/" + patient + "/h.wav")
        if talk == "Hallo":
            self.sound = QtGui.QSound("sound/" + patient + "/i.wav")
        if talk == "Goeden middag":
            self.sound = QtGui.QSound("sound/" + patient + "/j.wav")
        if talk == "Ja hoor het gaat goed zo":
            self.sound = QtGui.QSound("sound/" + patient + "/k.wav")
        if talk == "Deze situatie is niet erg angstig voor me":
            self.sound = QtGui.QSound("sound/" + patient + "/l.wav")
        if talk == "Het gaat nog wel goed":
            self.sound = QtGui.QSound("sound/" + patient + "/m.wav")
        if talk == "Ehmm, ik voel me niet zo goed...":
            self.sound = QtGui.QSound("sound/" + patient + "/n.wav")
        if talk == "Ik begin een beetje zenuwachtig te worden":
            self.sound = QtGui.QSound("sound/" + patient + "/o.wav")
        if talk == "Kunt u me alstublieft helpen?":
            self.sound = QtGui.QSound("sound/" + patient + "/p.wav")
        if talk == "Hallo is daar iemand?":
            self.sound = QtGui.QSound("sound/" + patient + "/q.wav")
        if talk == "Ik heb echt hulp nodig hier.":
            self.sound = QtGui.QSound("sound/" + patient + "/r.wav")


        self.sound.play()

    def imageUpdate(self, session):

        self.session = session

        sud = 3
        if self.session.sud > 6:
            sud = 6


        #sud = 3
        temp = random.randint(1,4)
        random.jumpahead(1)

        if self.session.patientName=="Mr.Aalders":

            sud = 3
            if sud == 3 and temp == 1:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p1/s31.jpg")
            if sud == 3 and temp == 2:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p1/s32.jpg")
            if sud == 3 and temp == 3:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p1/s33.jpg")
            if sud == 3 and temp == 4:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p1/s34.jpg")

        if self.session.patientName=="Mr.de Bruin":

            if sud == 6 and temp == 1:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p2/s61.jpg")
            if sud == 6 and temp == 2:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p2/s62.jpg")
            if sud == 6 and temp == 3:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p2/s63.jpg")
            if sud == 6 and temp == 4:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p2/s64.jpg")

            if sud == 3 and temp == 1:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p2/s31.jpg")
            if sud == 3 and temp == 2:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p2/s32.jpg")
            if sud == 3 and temp == 3:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p2/s33.jpg")
            if sud == 3 and temp == 4:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p2/s34.jpg")


        if self.session.patientName=="Mrs.Carstens":


            if sud == 6 and temp == 1:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p3/s61.jpg")
            if sud == 6 and temp == 2:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p3/s62.jpg")
            if sud == 6 and temp == 3:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p3/s63.jpg")
            if sud == 6 and temp == 4:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p3/s64.jpg")

            if sud == 3 and temp == 1:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p3/s31.jpg")
            if sud == 3 and temp == 2:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p3/s32.jpg")
            if sud == 3 and temp == 3:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p3/s33.jpg")
            if sud == 3 and temp == 4:
               self.parent.tpvw.w_pView.image = QtGui.QPixmap("images/p3/s34.jpg")



        self.parent.tpvw.w_pView.repaint()


    def viewUpdate(self):

        self.viewCount = self.viewCount + 1

        if self.viewCount > 2:
            self.viewCount = 0

            #sud
            temp = random.randint(1,3)
            random.jumpahead(1)
    
            temp2 = random.randint(0,20)
            random.jumpahead(1)
    
            if temp2 ==5:
                self.envirment = self.envirment+ 1
                if self.envirment == 4:
                    self.envirment = 1
    
            image = self.session.image
            if self.session.therapy=="Social":
                if temp == 1 and self.envirment == 1:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/r1.jpg")
                if temp == 2 and self.envirment == 1:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/r2.jpg")
                if temp == 3 and self.envirment == 1:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/r3.jpg")
                if temp == 1 and self.envirment == 2:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/b1.jpg")
                if temp == 2 and self.envirment == 2:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/b2.jpg")
                if temp == 3 and self.envirment == 2:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/b3.jpg")
                if temp == 1 and self.envirment == 3:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/w1.jpg")
                if temp == 2 and self.envirment == 3:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/w2.jpg")
                if temp == 3 and self.envirment == 3:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/sf/w3.jpg")



            if self.session.therapy=="Vlieg":
                if temp == 1:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/ff/1.jpg")
                if temp == 2:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/ff/2.jpg")
                if temp == 3:
                   self.parent.w_vwView.image= QtGui.QPixmap("images/ff/3.jpg")


            self.parent.w_vwView.repaint()




